; VERBOSE LIB !NOLINK
; 

    .486                      ; force 32 bit code
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive

    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\macros\macros.asm

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

    .code
; 

align 4

run_synch_process PROC lpCommand:DWORD

    LOCAL st_info:STARTUPINFO
    LOCAL pr_info:PROCESS_INFORMATION

  ; ---------------------
  ; zero fill STARTUPINFO
  ; ---------------------
    mov ecx, 17                 ; 68 bytes SIZEOF STARTUPINFO
    lea edx, st_info
    xor eax, eax
  @@:
    mov [edx], eax
    add edx, 4
    sub ecx, 1
    jnz @B
    mov st_info.dwFlags, STARTF_USESHOWWINDOW

    mov st_info.cb, 68          ; set the structure size member

    invoke CreateProcess,NULL,lpCommand,NULL,NULL,
                         NULL,NULL,NULL,NULL,
                         ADDR st_info,
                         ADDR pr_info

    test eax, eax               ; if CreateProcess fails
    jnz @F
    ;mov eax, -2                 ; set return value for CreateProcess fail
    ret

  @@:
    invoke SetPriorityClass,pr_info.hProcess,0

    invoke WaitForSingleObjectEx,pr_info.hProcess,INFINITE,0
    push   eax
    invoke GetExitCodeProcess, pr_info.hProcess, esp    ; pushes mem space for return value

    invoke CloseHandle, pr_info.hThread
    invoke CloseHandle, pr_info.hProcess

    pop eax                     ; return value from GetExitCodeProcess

    ret

comment * ---------------------------------
    WaitForSingleObjectEx return values

    WAIT_FAILED               equ -1
    WAIT_OBJECT_0             equ 0
    WAIT_ABANDONED            equ 00000080h
    WAIT_ABANDONED_0          equ 00000080h
    WAIT_TIMEOUT              equ 00000102h
    WAIT_IO_COMPLETION        equ 000000C0h
        --------------------------------- *

run_synch_process ENDP

end
